#!/usr/bin/python -W ignore::DeprecationWarning
import requests, json

def api_call(ip_addr, command, json_payload, sid):
    url = "https://" + ip_addr + ":" + "/web_api/" + command
    if sid == "":
        request_headers = {"Content-Type" : "application/json"}
    else:
        request_headers = {"Content-Type" : "application/json", "X-chkp-sid" : sid}
    r = requests.post(url,data=json.dumps(json_payload), headers=request_headers, verify=False)
    return r.json()


def login(user, password):
    payload = {"user": user, "password": password}
    response = api_call("192.168.48.198", "login", payload, "")
    return response["sid"]

### Define MGMT IP address and admin/password, get SID	
	
ip_addr = "192.168.48.198"
sid = login("admin", "vpn123")
print("session id: " + sid)


### Commands

add_net_data = {"name": "Internal", "subnet": "192.168.10.0", "subnet-mask": "255.255.255.0"}
add_net = api_call(ip_addr, "add-network", add_net_data, sid)
print(json.dumps(add_net))

add_gw_data = {
	"name": "GW-R80.10-API",
	"color": "black",
	"ipv4-address": "192.168.48.199",
	"version": "R80.10",
	"one-time-password": "sic123",
	"firewall": "true",
	"application-control": "true",
	"url-filtering": "true",
	"ips": "true",
	"anti-bot": "true",
	"anti-virus": "true",
	"interfaces": [{
			"name": "eth0",
			"ipv4-address": "192.168.48.199",
			"ipv4-network-mask": "255.255.255.0",
			"anti-spoofing": "true",
			"topology": "external"
		},
		{
			"name": "eth1",
			"ipv4-address": "192.168.10.199",
			"ipv4-network-mask": "255.255.255.0",
			"anti-spoofing": "true",
			"topology": "internal",
			"topology-settings": {
			"ip-address-behind-this-interface": "network defined by the interface ip and net mask"
			}
		}
	]
}
add_gw = api_call(ip_addr, "add-simple-gateway", add_gw_data, sid)
print(json.dumps(add_gw))

add_rule_data = {
	"layer": "Network",
	"position": "top", 
	"name": "MGMT rule", 
	"source": "SS-R80.10-MGMT-API",
	"destination": "GW-R80.10-API",
	"action": "Accept",
	"track": {
	"type": "Log"
	}
}
add_rule = api_call(ip_addr, "add-access-rule", add_rule_data, sid)
print(json.dumps(add_rule))


### Publish

publish_result = api_call(ip_addr, "publish", {}, sid)
print("publish result: " + json.dumps(publish_result))


### Install policy

install_policy_data = {
	"policy-package": "Standard",
	"access": "true",
	"targets": "GW-R80.10-API"
}
install_policy = api_call(ip_addr, "install-policy", install_policy_data, sid)
print(json.dumps(install_policy))


### Logout

logout_result = api_call(ip_addr, "logout", {}, sid)
print("logout result: " + json.dumps(logout_result))	